/* --------------------------------------------------------------  */
/* (C)Copyright 2007                                               */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

#ifndef __PIMC_H__
#define __PIMC_H__

// NOTE: This file requires that mc_rand_sb.h be included prior to it so that sobol_cntrlblck_t is defined.

#define UINT64 unsigned long long
#define UINT32 unsigned int
#define UINT16 unsigned short
#define UINT8  unsigned char

#define INT64 signed long long
#define INT32 signed int
#define INT16 signed short
#define INT8 signed char

#define TRUE 1
#define FALSE 0

#define __bitType_h__

typedef enum  {false = 0, true = 1} bool;
	
typedef union
{
	struct
	{
		UINT64 high;
		UINT64 low;
	} quad;
	
	struct
	{
		UINT32 w3;
		UINT32 w2;
		UINT32 w1;
		UINT32 w0;
	} word;
} UINT128;


#define MAX_DMA  0x1000 //0x1000  max value for 4k page size // 0x80 // 0x80 min value 
//#define PAD_SIZE 42
#define PAD_SIZE 38

// control block type for rand number generator
typedef struct
{
	UINT32 u32Len;						// number of random numbers to be created
	UINT32 u32Dim;						// dimension of the problem
	UINT32 u32Runs;						// number of runs of one experiment
	UINT32 u32Iter;						// number of iterations
	UINT32 u32Index;
	UINT32 u32Cycles;
        UINT32 u32RNG;

	// statistic results
        float pi;
	float mean;
	float sigma;
	float radius;
	float volume;
	float delta;

	char strRNG[12];					// text information
	sobol_cntrlblck_t sobolCB;				// control block for sobol RNs

	// padding to fill up 128 bytes
	// UINT8 padding[128 -12 - 6*sizeof(UINT32) - 5*sizeof(float) - sizeof(vector float *)- sizeof(sobol_cntrlblck_t)]; 
	UINT8 padding[PAD_SIZE];
} spu_rand_CB_t; //  __attribute__((__packed__));

#endif
