/* --------------------------------------------------------------  */
/* (C)Copyright 2007                                               */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

//sobol direction vector table for 30 bits and 40 dimension

#ifndef SOBOL_INIT_30_40_H
	#define SOBOL_INIT_30_40_H
	//sobol direction vector table for 30 bits and 40 dimension
	#undef UINT32
	#define UINT32 unsigned int
	
	/* maximum allowed space dimension */
	#define SOBOL_MAX_DIMENSION 40
	/* bit count; assumes sizeof(int) >= 32-bit */
	#define SOBOL_BIT_COUNT 30

vector UINT32 u32_vecDirections[(SOBOL_BIT_COUNT+3)>>2][SOBOL_MAX_DIMENSION] = {
{ { 536870912, 268435456, 134217728, 67108864 },{ 536870912, 805306368, 671088640, 1006632960 },{ 536870912, 268435456, 939524096, 738197504 },{ 536870912, 805306368, 939524096, 335544320 },{ 536870912, 268435456, 671088640, 201326592 },{ 536870912, 805306368, 134217728, 67108864 },{ 536870912, 268435456, 402653184, 469762048 },{ 536870912, 805306368, 402653184, 603979776 },{ 536870912, 805306368, 939524096, 872415232 },{ 536870912, 268435456, 671088640, 738197504 },{ 536870912, 805306368, 671088640, 67108864 },{ 536870912, 268435456, 939524096, 201326592 },{ 536870912, 805306368, 939524096, 469762048 },{ 536870912, 268435456, 134217728, 603979776 },{ 536870912, 805306368, 402653184, 335544320 },{ 536870912, 268435456, 402653184, 872415232 },{ 536870912, 268435456, 939524096, 872415232 },{ 536870912, 805306368, 671088640, 738197504 },{ 536870912, 268435456, 134217728, 201326592 },{ 536870912, 805306368, 134217728, 1006632960 },{ 536870912, 268435456, 671088640, 335544320 },{ 536870912, 805306368, 402653184, 201326592 },{ 536870912, 268435456, 402653184, 1006632960 },{ 536870912, 805306368, 134217728, 469762048 },{ 536870912, 805306368, 939524096, 603979776 },{ 536870912, 268435456, 671088640, 872415232 },{ 536870912, 805306368, 134217728, 603979776 },{ 536870912, 268435456, 402653184, 67108864 },{ 536870912, 805306368, 402653184, 738197504 },{ 536870912, 268435456, 939524096, 469762048 },{ 536870912, 805306368, 671088640, 335544320 },{ 536870912, 268435456, 134217728, 1006632960 },{ 536870912, 268435456, 134217728, 67108864 },{ 536870912, 805306368, 671088640, 1006632960 },{ 536870912, 268435456, 939524096, 738197504 },{ 536870912, 805306368, 939524096, 335544320 },{ 536870912, 268435456, 671088640, 201326592 },{ 536870912, 805306368, 134217728, 67108864 },{ 536870912, 268435456, 402653184, 469762048 },{ 536870912, 805306368, 402653184, 603979776 } },
{ { 33554432, 16777216, 8388608, 4194304 },{ 570425344, 855638016, 713031680, 1069547520 },{ 436207616, 1023410176, 562036736, 331350016 },{ 234881024, 721420288, 411041792, 616562688 },{ 503316480, 855638016, 1048576000, 591396864 },{ 301989888, 989855744, 209715200, 373293056 },{ 1040187392, 788529152, 914358272, 725614592 },{ 301989888, 956301312, 360710144, 180355072 },{ 100663296, 587202560, 746586112, 37748736 },{ 905969664, 889192448, 578813952, 104857600 },{ 503316480, 318767104, 947912704, 482344960 },{ 973078528, 855638016, 394264576, 406847488 },{ 704643072, 1023410176, 461373440, 79691776 },{ 771751936, 620756992, 813694976, 406847488 },{ 637534208, 553648128, 25165824, 826277888 },{ 369098752, 117440512, 310378496, 423624704 },{ 838860800, 83886080, 696254464, 1069547520 },{ 234881024, 184549376, 864026624, 121634816 },{ 436207616, 654311424, 226492416, 851443712 },{ 570425344, 1056964608, 109051904, 272629760 },{ 33554432, 452984832, 276824064, 817889280 },{ 838860800, 285212672, 964689920, 742391808 },{ 973078528, 251658240, 343932928, 440401920 },{ 100663296, 385875968, 662700032, 71303168 },{ 1040187392, 486539264, 142606336, 197132288 },{ 369098752, 50331648, 243269632, 708837376 },{ 167772160, 352321536, 998244352, 457179136 },{ 771751936, 218103808, 629145600, 624951296 },{ 905969664, 520093696, 612368384, 62914560 },{ 637534208, 419430400, 880803840, 893386752 },{ 704643072, 150994944, 58720256, 566231040 },{ 167772160, 822083584, 494927872, 1061158912 },{ 33554432, 553648128, 545259520, 801112064 },{ 570425344, 318767104, 176160768, 650117120 },{ 436207616, 486539264, 25165824, 734003200 },{ 234881024, 184549376, 947912704, 264241152 },{ 503316480, 318767104, 511705088, 197132288 },{ 301989888, 452984832, 746586112, 29360128 },{ 1040187392, 251658240, 377487360, 96468992 },{ 301989888, 419430400, 897581056, 163577856 } },
{ { 2097152, 1048576, 524288, 262144 },{ 538968064, 808452096, 673710080, 1010565120 },{ 975175680, 756023296, 431489024, 1072431104 },{ 920649728, 1062207488, 381157376, 258736128 },{ 371195904, 795869184, 139984896, 482082816 },{ 673185792, 875560960, 436731904, 1057226752 },{ 379584512, 995098624, 246939648, 659292160 },{ 471859200, 118489088, 839385088, 151781376 },{ 492830720, 974127104, 703070208, 1012662272 },{ 216006656, 644874240, 478674944, 256114688 },{ 861929472, 164626432, 904396800, 907804672 },{ 488636416, 40894464, 1059586048, 762576896 },{ 123731968, 797966336, 998768640, 885784576 },{ 740294656, 177209344, 196608000, 353632256 },{ 689963008, 1030750208, 468189184, 980156416 },{ 970981376, 688914432, 838336512, 90963968 },{ 807403520, 678428672, 217579520, 101449728 },{ 232783872, 609222656, 317194240, 755236864 },{ 996147200, 529530880, 429391872, 739508224 },{ 945815552, 873463808, 511180800, 490995712 },{ 551550976, 145752064, 479723520, 513540096 },{ 39845888, 154140672, 899153920, 505675776 },{ 522190848, 212860928, 641204224, 626262016 },{ 576716800, 84934656, 716701696, 852230144 },{ 773849088, 353370112, 347602944, 301203456 },{ 824180736, 869269504, 329777152, 63700992 },{ 350224384, 1037041664, 275251200, 946077696 },{ 698351616, 393216000, 245891072, 296484864 },{ 991952896, 382730240, 514326528, 445906944 },{ 983564288, 137363456, 873988096, 37486592 },{ 211812352, 225443840, 832045056, 351010816 },{ 44040192, 768606208, 655884288, 916717568 },{ 945815552, 472907776, 236453888, 655097856 },{ 480247808, 468713472, 252182528, 411828224 },{ 517996544, 185597952, 378011648, 257687552 },{ 622854144, 59768832, 253231104, 1054081024 },{ 845152256, 493879296, 633864192, 425984000 },{ 1042284544, 1026555904, 763887616, 843317248 },{ 127926272, 206569472, 217579520, 304873472 },{ 757071872, 263192576, 752353280, 780402688 } },
{ { 131072, 65536, 32768, 16384 },{ 572653568, 858980352, 715816960, 1073725440 },{ 540672000, 271384576, 941195264, 742375424 },{ 771883008, 453181440, 545488896, 817971200 },{ 908197888, 1064370176, 542801920, 280805376 },{ 512884736, 763035648, 615284736, 577126400 },{ 814088192, 140705792, 103841792, 587743232 },{ 226885632, 784924672, 237273088, 1042169856 },{ 176553984, 289472512, 166690816, 206946304 },{ 812253184, 960167936, 82149376, 444153856 },{ 369229824, 655163392, 244154368, 197509120 },{ 715522048, 171376640, 436764672, 587972608 },{ 1064173568, 865533952, 293765120, 163790848 },{ 671219712, 872480768, 637566976, 16924672 },{ 1005191168, 175046656, 602636288, 510541824 },{ 325189632, 340852736, 102334464, 528433152 },{ 930742272, 751632384, 383352832, 259932160 },{ 350879744, 973537280, 23625728, 440778752 },{ 184156160, 797245440, 23232512, 680640512 },{ 972947456, 382533632, 671121408, 201375744 },{ 95027200, 353042432, 631930880, 84623360 },{ 323092480, 818085888, 427851776, 474005504 },{ 61734912, 848363520, 1059094528, 481312768 },{ 378404864, 83820544, 159416320, 1061208064 },{ 224788480, 12255232, 402554880, 878690304 },{ 733347840, 533004288, 161513472, 177225728 },{ 745668608, 774569984, 520650752, 787791872 },{ 57802752, 948371456, 413696000, 145506304 },{ 415367168, 499056640, 275415040, 673955840 },{ 587857920, 195362816, 412647424, 997998592 },{ 827195392, 267452416, 938377216, 998359040 },{ 466223104, 473366528, 439910400, 959725568 },{ 63307776, 776142848, 926842880, 197083136 },{ 495583232, 707723264, 520781824, 15712256 },{ 418775040, 607977472, 504791040, 321732608 },{ 683278336, 133103616, 153255936, 435929088 },{ 666501120, 1007353856, 638746624, 924794880 },{ 24248320, 432734208, 36995072, 591249408 },{ 959840256, 495648768, 829718528, 861192192 },{ 224526336, 761331712, 490831872, 89374720 } },
{ { 8192, 4096, 2048, 1024 },{ 536879104, 805318656, 671098880, 1006648320 },{ 438312960, 1024462848, 565721088, 334244864 },{ 954261504, 340963328, 238651392, 732843008 },{ 673439744, 208809984, 517564416, 872346624 },{ 838868992, 184561664, 75499520, 306185216 },{ 277225472, 409145344, 506501120, 1057512448 },{ 663576576, 63877120, 295766016, 702071808 },{ 847421440, 625233920, 266500096, 793973760 },{ 42639360, 374247424, 618969088, 176151552 },{ 367632384, 101969920, 1040906240, 587809792 },{ 797270016, 340381696, 657205248, 830098432 },{ 619241472, 928395264, 383997952, 643343360 },{ 511893504, 1027756032, 480446464, 315720704 },{ 99213312, 1064062976, 74053632, 237978624 },{ 639328256, 259878912, 1041934336, 998233088 },{ 402825216, 604114944, 167917568, 822144000 },{ 822632448, 844460032, 495147008, 1010893824 },{ 471408640, 316059648, 731609088, 387210240 },{ 704651264, 50393088, 612403200, 792787968 },{ 229253120, 285937664, 262809600, 168524800 },{ 442523648, 87044096, 127453184, 254034944 },{ 1043881984, 424996864, 967763968, 1032928256 },{ 199237632, 173043712, 693639168, 614226944 },{ 908091392, 17846272, 314054656, 687137792 },{ 67674112, 777834496, 524179456, 752421888 },{ 553263104, 262115328, 689088512, 767267840 },{ 284319744, 348590080, 982005760, 933000192 },{ 875094016, 441741312, 694335488, 1001376768 },{ 128638976, 110456832, 1040193536, 352330752 },{ 771104768, 447582208, 974686208, 288142336 },{ 569516032, 889450496, 868919296, 808944640 },{ 704684032, 889212928, 713041920, 180392960 },{ 162144256, 874459136, 774023168, 424901632 },{ 715022336, 762441728, 703072256, 1066173440 },{ 171466752, 222597120, 530765824, 758873088 },{ 216014848, 112226304, 1068029952, 135560192 },{ 547364864, 401616896, 925370368, 179569664 },{ 309207040, 334958592, 481990656, 552852480 },{ 559423488, 860106752, 708974592, 533799936 } },
{ { 512, 256, 128, 64 },{ 570434048, 855651072, 713042560, 1069563840 },{ 976886272, 757939456, 429498752, 1073730496 },{ 417426944, 609285376, 909831040, 1068349120 },{ 1040351744, 587253504, 377613696, 792936384 },{ 975180288, 254819072, 378014848, 692328000 },{ 780541440, 929251072, 682667648, 340293440 },{ 1008730624, 923796224, 705167744, 755761728 },{ 503620096, 654660352, 311294848, 356964160 },{ 713687552, 977993984, 317555328, 1065173696 },{ 277586432, 416215808, 762280576, 449872960 },{ 681927168, 892981504, 931408768, 139349184 },{ 527303168, 60228352, 696419200, 365117888 },{ 664453632, 528787712, 599440256, 554979648 },{ 759917056, 861704960, 916640896, 154351040 },{ 672759296, 1014800640, 983095168, 624947904 },{ 461552128, 985737984, 430003584, 397482944 },{ 375490048, 252723456, 285878400, 39080256 },{ 360312320, 910628096, 763432832, 583043136 },{ 1054874112, 609239296, 639164800, 693424192 },{ 522873344, 986431232, 1070262656, 846962112 },{ 717415936, 478392576, 467700096, 359720128 },{ 731959808, 116402432, 555228288, 367313600 },{ 970366464, 929239296, 399903104, 207868992 },{ 1004984832, 377182976, 828250752, 714062656 },{ 1061075456, 1020913920, 389997696, 148463424 },{ 671108608, 335559936, 33577856, 822096704 },{ 310048256, 928744704, 519216768, 164047296 },{ 660785664, 951038720, 769826432, 141501504 },{ 713044480, 809542912, 673215104, 611337408 },{ 1072563712, 528610048, 804656256, 128800448 },{ 406377984, 875842816, 913441408, 994280256 },{ 450923008, 317733632, 385377152, 352112576 },{ 629703168, 239920896, 690647168, 232736960 },{ 681479680, 208759552, 174626176, 625784640 },{ 798513664, 353686272, 999986816, 461332800 },{ 477233664, 913269504, 522728320, 13900480 },{ 14291456, 230628096, 38710400, 158515648 },{ 606903808, 841539328, 689974912, 93325760 },{ 370774528, 991418624, 882513280, 408238528 } },
{ { 32, 16, 8, 4 },{ 538976288, 808464432, 673720360, 1010580540 },{ 536877600, 268451088, 939532728, 738202604 },{ 383778848, 256901168, 783810616, 460062740 },{ 136568864, 477245456, 920217640, 1073673228 },{ 917645344, 424358960, 1050974728, 492994308 },{ 942016672, 204670032, 638099512, 855920652 },{ 528875808, 399049616, 463765848, 886980780 },{ 937820768, 458293552, 403145032, 67748708 },{ 134259552, 1006998352, 503921192, 419601508 },{ 224396256, 718275120, 627573000, 786170252 },{ 623075744, 243192368, 86289144, 510758212 },{ 250143392, 173421520, 224614840, 580428876 },{ 234881056, 889192464, 947912712, 1010827300 },{ 223046176, 56398640, 782423192, 489895380 },{ 58286112, 204238864, 847456280, 155227188 },{ 1020836384, 779889424, 998299064, 717446132 },{ 897680928, 272646448, 409086120, 68178284 },{ 861982240, 328312080, 60454792, 185914444 },{ 663124448, 193557776, 301885432, 449682228 },{ 592616416, 753395632, 653823304, 971813788 },{ 804828768, 454314128, 349865224, 1072137996 },{ 529952992, 415607120, 672062648, 878830404 },{ 1045826272, 52656944, 1035395640, 359923708 },{ 213420640, 99894160, 191266680, 968597820 },{ 20854432, 198808368, 264170712, 563694100 },{ 830506912, 239130768, 794823752, 646980332 },{ 117984416, 383550384, 366637896, 757832668 },{ 71478816, 41893136, 88781736, 234561452 },{ 976749152, 1062002160, 766666408, 27856468 },{ 328784608, 971796848, 818821592, 858860980 },{ 753549920, 581411728, 1031844776, 792758940 },{ 901700064, 360705264, 987805560, 49308988 },{ 839019680, 191044336, 513815176, 955256396 },{ 771671968, 832638512, 58763896, 180401604 },{ 817500384, 602872080, 1059200136, 117132268 },{ 412286624, 752820304, 377549256, 398498236 },{ 499555872, 272026928, 942966152, 205375044 },{ 760750496, 226238288, 491660408, 90642668 },{ 922465568, 1001843632, 385588952, 196528004 } },
{ { 2, 1, 0, 0 },{ 572662306, 858993459, 0, 0 },{ 436222522, 1023421741, 0, 0 },{ 537001998, 805503019, 0, 0 },{ 537035294, 268486451, 0, 0 },{ 747781778, 645602683, 0, 0 },{ 144717862, 72354867, 0, 0 },{ 1001218498, 81703025, 0, 0 },{ 1040490934, 386224529, 0, 0 },{ 344629966, 860787559, 0, 0 },{ 996278998, 1037894061, 0, 0 },{ 1025507442, 309330455, 0, 0 },{ 403571318, 738656761, 0, 0 },{ 35651630, 797966373, 0, 0 },{ 726362630, 576492305, 0, 0 },{ 568466966, 487706887, 0, 0 },{ 564140562, 598948629, 0, 0 },{ 579569198, 85410107, 0, 0 },{ 125378618, 491171895, 0, 0 },{ 33554434, 251658243, 0, 0 },{ 55745506, 1021831089, 0, 0 },{ 859963394, 12779523, 0, 0 },{ 507011074, 156561409, 0, 0 },{ 317587458, 653197315, 0, 0 },{ 561918050, 580864147, 0, 0 },{ 1050583042, 306827265, 0, 0 },{ 76049922, 95726851, 0, 0 },{ 903542274, 1026262273, 0, 0 },{ 939549730, 469798419, 0, 0 },{ 260715010, 853910785, 0, 0 },{ 315554530, 506585459, 0, 0 },{ 178320898, 298892545, 0, 0 },{ 519631842, 284985329, 0, 0 },{ 763915426, 38542067, 0, 0 },{ 1029744546, 298909233, 0, 0 },{ 1018710754, 159697427, 0, 0 },{ 73456802, 40907601, 0, 0 },{ 371211122, 154154699, 0, 0 },{ 425895958, 659543067, 0, 0 },{ 251363554, 800518305, 0, 0 } }
};

inline static void rand_sobol_set_CB(sobol_cntrlblck_t *sobolCB, UINT32 u32Seed)
{
        sobolCB->pu32_vecDirection = &u32_vecDirections[0][0];
        sobolCB->u32sizeofTable = sizeof(u32_vecDirections);
        sobolCB->u32TableDimension = SOBOL_MAX_DIMENSION;
        sobolCB->u32TableBitCount = (SOBOL_BIT_COUNT+3)&0xFFFFFFFC;
        sobolCB->u32MaxBitCount = SOBOL_BIT_COUNT;
        sobolCB->u32Seed = u32Seed;

	return;
}

#endif
