/* --------------------------------------------------------------  */
/* (C)Copyright 2007                                               */
/* International Business Machines Corporation                     */
/* All Rights Reserved.                                            */
/*                                                                 */
/* Redistribution and use in source and binary forms, with or      */
/* without modification, are permitted provided that the           */
/* following conditions are met:                                   */
/*                                                                 */
/* - Redistributions of source code must retain the above copyright*/
/*   notice, this list of conditions and the following disclaimer. */
/*                                                                 */
/* - Redistributions in binary form must reproduce the above       */
/*   copyright notice, this list of conditions and the following   */
/*   disclaimer in the documentation and/or other materials        */
/*   provided with the distribution.                               */
/*                                                                 */
/* - Neither the name of IBM Corporation nor the names of its      */
/*   contributors may be used to endorse or promote products       */
/*   derived from this software without specific prior written     */
/*   permission.                                                   */
/*                                                                 */
/* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND          */
/* CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,     */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE        */
/* DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR            */
/* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
/* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT    */
/* NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;    */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)        */
/* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN       */
/* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR    */
/* OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,  */
/* EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.              */
/* --------------------------------------------------------------  */
/* PROLOG END TAG zYx                                              */

#ifndef __MY_TYPE_H__
#define __MY_TYPE_H__

#include <stdlib.h>

// NOTE: This file requires that mc_rand_sb.h be included prior to it so that sobol_cntrlblck_t is defined.

#ifndef __bitType_h__
	#define UINT64 unsigned long long
	#define UINT32 unsigned int
	#define UINT16 unsigned short
	#define UINT8  unsigned char

	#define INT64 signed long long
	#define INT32 signed int
	#define INT16 signed short
	#define INT8 signed char

	#define TRUE 1
	#define FALSE 0

	#define __bitType_h__
#endif

#define MAX_DMA  0x4000 //0x4000  max value for DMA 16k  // 0x80 min value = 128 bytes  

#define PAD_SIZE 42

// control block type for rand number generator
typedef struct
{
	UINT32 u32Len;							// number of random numbers to be created
	UINT32 u32Dim;							// dimension of the problem
	UINT32 u32Runs;							// number of runs of one experiment
	UINT32 u32Iter;							// number of iterations
	UINT32 u32Index;
	UINT32 u32Cycles;
	vector float * pfRandBufferMainMem;		// pointer to buffer in main memory
	// statistic results
	float mean;
	float sigma;
	float radius;
	float volume;
	float delta;

	char strRNG[36];						// text information
	sobol_cntrlblck_t sobolCB;				// control block for sobol RNs
	
	// padding to fill up 128 bytes
	UINT8 padding[128 -36 - 6*sizeof(UINT32) - 5*sizeof(float) - sizeof(vector float *)- sizeof(sobol_cntrlblck_t)]; 
} spu_rand_CB_t; //  __attribute__((__packed__));

#endif
