/* --------------------------------------------------------------- */
/* Licensed Materials - Property of IBM                            */
/* 5724-S84                                                        */
/* (C) Copyright IBM Corp. 2007       All Rights Reserved          */
/* US Government Users Restricted Rights - Use, duplication or     */
/* disclosure restricted by GSA ADP Schedule Contract with         */
/* IBM Corp.                                                       */
/* --------------------------------------------------------------- */
/* PROLOG END TAG zYx                                              */
// ***************************************************************************
// ks_spu.h
// 04-09-07 CEB - rev12, change constants to multiples of 4.
// 04-12-07 CEB - rev14, added DMA macro
// 05-02-07 CEB - rev18, support for double precision, prep for code review
// 06-08-07 CEB - rev25
// ***************************************************************************
#ifndef _MC_RAND_KS_H_
#define _MC_RAND_KS_H_

//
//  C++ interface
//
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

// Initialization routine
void mc_rand_ks_init( unsigned int seed );

// Return single vectors of RNGs
vector unsigned int mc_rand_ks_u4( void );
vector float mc_rand_ks_0_to_1_f4( void );
vector float mc_rand_ks_minus1_to_1_f4( void );
vector double mc_rand_ks_0_to_1_d2( void );
vector double mc_rand_ks_minus1_to_1_d2( void );

// Return more than one vector of RNGs
void mc_rand_ks_array_u4(unsigned int, vector unsigned int *);
void mc_rand_ks_0_to_1_array_f4(unsigned int, vector float *);
void mc_rand_ks_minus1_to_1_array_f4(unsigned int, vector float *);
void mc_rand_ks_0_to_1_array_d2(unsigned int, vector double *);
void mc_rand_ks_minus1_to_1_array_d2(unsigned int, vector double *);

//
//  C++ interface
//
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
