/* --------------------------------------------------------------- */
/* Licensed Materials - Property of IBM                            */
/* 5724-S84                                                        */
/* (C) Copyright IBM Corp. 2007       All Rights Reserved          */
/* US Government Users Restricted Rights - Use, duplication or     */
/* disclosure restricted by GSA ADP Schedule Contract with         */
/* IBM Corp.                                                       */
/* --------------------------------------------------------------- */
/* PROLOG END TAG zYx                                              */
#ifndef _MC_RAND_MT_H_
#define _MC_RAND_MT_H_

//
//  C++ interface
//
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

// Initialization routine
void mc_rand_mt_init(const unsigned int seed);

// Return single vectors of RNGs
vector unsigned int mc_rand_mt_u4();
vector float mc_rand_mt_minus1_to_1_f4();
vector float mc_rand_mt_0_to_1_f4();
vector double mc_rand_mt_0_to_1_d2();
vector double mc_rand_mt_minus1_to_1_d2();

// Return more than one vector of RNGs
void mc_rand_mt_array_u4( unsigned int count, vector unsigned int *array );
void mc_rand_mt_0_to_1_array_f4( unsigned int count, vector float *array );
void mc_rand_mt_minus1_to_1_array_f4( unsigned int count, vector float *array );
void mc_rand_mt_0_to_1_array_d2( unsigned int count, vector double *array );
void mc_rand_mt_minus1_to_1_array_d2( unsigned int count, vector double *array );

//
//  C++ interface
//
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _MC_RAND_MT_H */
